import pygame, random
from baseSprite import BaseSprite
import crashteroidsconfig

class Bullet(BaseSprite):
    def __init__(self,x,y,orientation, imgName = None):
        img = "bullet.png"
        if imgName != None:
            img = imgName 
        BaseSprite.__init__(self, img)
        self.launchSound = pygame.mixer.Sound(crashteroidsconfig.guy_shoot_sound)
        self.launchSound.set_volume(.05)
        self.launchSound.play()
        self.explosionSound = pygame.mixer.Sound(crashteroidsconfig.guy_bullet_explode)
        self.explosionSound.set_volume(.2)
        self.orientation = orientation
        self.x = x
        self.y = y
        self._accelerating = True
        self.acceleration_divisor = .75
        self.max_velocity = 100
        self.maxticks = 10
        self.ticks = 0
        self.exploding = False
        self.explodestage = 0
        self._update_image()
  
    def update(self):
        BaseSprite.update(self)
        self.ticks += 1
        if not self.exploding and self.ticks > self.maxticks:
            self.kill()

        if self.exploding: 
            self.explodestage += 1
            e = self.explodestage
            if e < 5:
                e = str(e)
                self.masterImage = pygame.image.load(crashteroidsconfig.bullet_explode_stage + e  + ".png")
                self._update_image()
            else:
                self.kill()
   
    def explode(self):
        self._accelerating = False
        self.velocity_x = 0
        self.velocity_y = 0
        self.explosionSound.play()
        self.exploding = True
   
